﻿{*******************************************************}
{                                                       }
{       TDX Stock Plugin                                }
{                                                       }
{       Copyright (C) 2008 SharpPlus                    }
{                                                       }
{*******************************************************}

library MyPlugin;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Dialogs,
  Windows,
  Math,
  Plugin in 'Plugin.pas',
  OutStruct in 'OutStruct.pas';

{$R *.res}

type
  TCalcFunc=function (Code:PChar;nSetCode, DataType:SmallInt;PDat:PHisDat;nDataNum:SmallInt;
  time1,time2:TNTime;nTQ:Byte;unused:Cardinal):LongInt;stdcall;

var
  m_pfn:TCalcFunc;//

const	g_nAvoidMask:array [0..3] of Byte=($F8,$F8,$F8,$F8);	// 无效数据标志(系统定义)

procedure SetArrayValue(PData:PSingle;Index:Integer;AValue:Single);
begin
  Inc(PData, Index);
  PData^:=AValue;
end;

function GetArrayValue(PData:PSingle;Index:Integer):Single;
begin
  Inc(PData, Index);
  Result:=PData^;
end;

function   AfxRightData(pData:PSingle;nMaxData:Word):Word;	//获取有效数据位置
var
  nIndex:Word;
begin
	for nIndex:=0 to nMaxData-1 do
  begin
    //memcmp(&pData[nIndex],g_nAvoidMask,4);;
    if CompareMem(pData, @g_nAvoidMask,4) then
    begin
     Inc(PData);
     Continue;
    end;
    Result:=nIndex;
    Exit;
  end;
end;

procedure   AfxCalcMa(pData:PSingle;nData:Cardinal;nParam:Word);
var
  i:Cardinal;
  nMinEx:Word;
  nDataEx, nDataSave:Single;
  MaPtr, DataPtr:PSingle;

begin
	if(pData=nil) or (nData=0) or (nParam=1) then
    Exit;
	i:=nData-nParam+1;
  nMinEx:=AfxRightData(pData,nData);
	if(nParam=0) or (nParam+nMinEx>nData) then
    nMinEx:=nData
	else
	begin
		nDataEx:=0;
    nDataSave:=0;
		MaPtr:=PData;
    Inc(MaPtr, nData-1);
    DataPtr:=pData;
    Inc(DataPtr, nData-nParam);
{
		for(nMinEx+=nParam-1;i<nData;nDataEx+=pData[i++]);
		for(i=nData-1;i>=nMinEx;i--,MaPtr--,DataPtr--)
		{
			nDataEx+=(*DataPtr);
			nDataSave=(*MaPtr);
			*MaPtr=nDataEx/nParam;
			nDataEx-=nDataSave;
		}

	end;
end;

function AfxCross(psData, plData:PSingle;nIndex:Word;var nCross:Single):Word;
var
  nDif:Single;
  nDifEx:Single;
  nRatio:Single;
  tmpPsP, tmpPlP:PSingle;
  tmpPs,tmpPl, tmpPs2, tmpPl2:Single;
begin
	if(psData=nil) or (plData=nil) or (nIndex=0) then
  begin
   Result:=0;
   Exit;
  end;

  tmpPsP:=psData;
  tmpPlP:=plData;

  Inc(tmpPsP, nIndex-1);
  Inc(tmpPlP, nIndex-1);
  tmpPs:=tmpPsP^;
  tmpPl:=tmpPlP^;

  Inc(tmpPsP);
  Inc(tmpPlP);
  tmpPs2:=tmpPsP^;
  tmpPl2:=tmpPlP^;


	nDif:=tmpPs-tmpPl;
	nDifEx:=tmpPl2-tmpPs2;

  if (nDif+nDifEx)<>0 then
    nRatio:=nDif/(nDif+nDifEx)
  else
    nRatio:=0;

	nCross:=tmpPs+(tmpPs2-tmpPs)*nRatio;

	if(nDif<0) and (nDifEx<0) then
  begin
  	result:=1;
    Exit;
  end;
	if(nDif>0) and (nDifEx>0) then
  begin
  	Result:=2;
    Exit;
  end;

	Result:=0;
end;

procedure RegisterDataInterface(pfn:TCalcFunc);cdecl;
begin
  ShowMessage('RegisterDataInterface');

  m_pfn:=pfn;
end;

procedure GetCopyRightInfo(info:PPlugInfo);cdecl;
var
  AInfo:TPlugInfo;
  PInfo:PPlugInfo;
begin
	//填写基本信息
  StrCopy(info.Name, 'MA Cross');
  StrCopy(info^.Dy, 'Beijing');
	StrCopy(info^.Author,'hubdog');
	StrCopy(info^.Period,'Short');
	StrCopy(info^.Descript,'2 MA Cross');
	StrCopy(info^.OtherInfo,'2 MA Cross');

	//填写参数信息
	info^.ParamNum := 2;

	StrCopy(info^.ParamInfo[0].acParaName,'MA1');
	info^.ParamInfo[0].nMax:=1;
	info^.ParamInfo[0].nMax:=1000;
	info^.ParamInfo[0].nDefault:=13;
	StrCopy(info^.ParamInfo[1].acParaName,'MA2');
	info^.ParamInfo[1].nMax:=1;
	info^.ParamInfo[1].nMax:=1000;
	info^.ParamInfo[1].nDefault:=30;
end;

function InputInfoThenCalc1(Code:PChar;nSetCode:SmallInt;PValue:PInteger;DataType:SmallInt;nDataNum:SmallInt;nTQ:Byte;
unused:Cardinal):Integer;cdecl; //按最近数据计算,取所有历史数据
var
  nRet:Integer;
  tmpTime:TNTime;
  pHDat:PHisDat;
  readnum:Cardinal;
  pMa1:PSingle;
  pMa2:PSingle;
  I:Cardinal;
  nCross:Single;
  value0, value1:Integer;
  OldP:PHisDat;
  OldMa1,OldMa2:PSingle;
  Handle:THandle;
begin
	nRet := 0;
  FillChar(tmpTime, sizeof(TNTime),0 );

  GetMem(pHDat, nDataNum*Sizeof(THisDat));  //数据缓冲区
  //FillChar(pHDat,nDataNum*Sizeof(THisDat), 0 );

	readnum := m_pfn(Code,nSetCode,DataType,pHDat,nDataNum,tmpTime,tmpTime,nTQ,0);  //利用回调函数申请数据，返回得到的数据个数

  value0:=PValue^;
  Inc(PValue);
  value1:=PValue^;

	if( readnum > max(Value0,Value1) ) then//只有数据个数大于Value[0]和Value[1]中的最大值才有意义
	begin
		GetMem(pMa1, readnum*sizeof(Single));
		GetMem(pMa2, readnum*sizeof(Single));

    OldP:=PHDat;
    OldMa1:=pMa1;
    OldMa2:=pMa2;
    for I := 0 to readnum - 1 do
    begin
			pMa1^:= pHDat^.Close;
			pMa2^:= pHDat^.Close;
      Inc(pHDat);
      Inc(PMa1);
      Inc(PMa2);
		end;
    PMa2:=OldMa2;
    PMa1:=OldMa1;
    pHDat:=OldP;
		//AfxCalcMa(pMa1,readnum,Value0);	//计算MA
		//AfxCalcMa(pMa2,readnum,Value1);
		//if(AfxCross(pMa1,pMa2,readnum-1,nCross) = 1) then	//判断是不是在readnum-1(最后一个数据)处交叉 1:上穿 2:下穿
		//	nRet := 1;  //返回为真，符合选股条件

		FreeMem(PMa2);
		FreeMem(PMa1);
	end;

	FreeMem(pHDat);
	Result:=0;
end;

function InputInfoThenCalc2(Code:PChar;nSetCode:SmallInt;PValue:PInteger;DataType:SmallInt;time1,time2:TNTime;nTQ:Byte;
unused:Cardinal):Integer;cdecl; //选取区段计算
var
  readnum:Cardinal;
begin
	readnum := m_pfn(Code,nSetCode,DataType,nil,-1,time1,time2,nTQ,0);  //利用回调函数申请数据，返回得到的数据个数
  ShowMessage(IntToStr(readnum));
  Result:=0;
end;

exports
RegisterDataInterface,
GetCopyRightInfo,
InputInfoThenCalc1,
InputInfoThenCalc2;

begin
end.
