﻿{*******************************************************}
{                                                       }
{       Stock Header                                    }
{                                                       }
{       Copyright (C) 2008 SharpPlus                    }
{                                                       }
{*******************************************************}

unit OutStruct;

interface
uses Messages, Classes;

type

  tag_NTime=packed record
    year:Word ;
    month:Byte;
    day:Byte ;
    hour:Byte;
    minute:Byte;
    second:Byte;
  end;

  TNTime=tag_NTime;

  tag_HISDAT=packed record
    Time:TNTime;			//时间
    Open:Single;			//单位开盘价
    High:Single;			//单位最高价
    Low:Single;			//单位最低价
    Close:Single;		//单位收盘价
    Amount:Single;
    Volume:Cardinal;       //单位成交量,指数无成交量
    case Integer of
    0:
      (YClose:Single);
    1:(
       up:Word;                // 上涨家数
       down:Word              // 下跌家数
      );						// 单位前收盘价(除权用)，期货的持仓量
  end;

  THisDat=tag_HISDAT;
  PHisDat=^THisDat;

  ExDayInfo=packed record
	  dwDate:Cardinal;     //日期
    nStockNum:SmallInt;  //当天交易股票数
	  nUpIdx:SmallInt;     //个股涨幅名次
	  dwInVol:Cardinal;    //买盘成交量
	  dwFirstVol:Cardinal; //集合竞价成交量
	  fLast5ZDFD:Single; //最后5分钟振动幅度
	  wNoCjMinute:Cardinal;//没有成交的分钟数
	  wCjbs:Cardinal;      //总成交笔数
    case Integer of
      0:
       (Yjlx:Single);	  //如果是国债,是当天利息
		  1:
       (Lead:Single);	  //如果是指数,是当天最后时刻的领先值
      2:
		   (Other:Single);  //对于AB股,暂未用
   end;

   TEXDAYINFO=packed record
     Info:ExDayInfo;
	   strNoUsed:array [0..3] of char;//备用字段
   end;


   tag_REPORTDAT=record
     ItemNum:Word;              // 采样点数
     Close:Single;                // 前收盘价
     Open:Single;                 // 今开盘价
     Max:Single;                  // 最高价
     Min:Single;                  // 最低价
     Now:Single;                  // 现价
     Volume:Cardinal;               // 总手
     NowVol:Cardinal;               // 现手(总手差)
     Amount:Single;               // 总成交金额
     Inside:Cardinal;               // 内盘
     Outside:Cardinal;              // 外盘
     TickDiff:Single;             // 笔涨跌(价位差)
     InOutFlag:BYTE;			 // 内外盘标志 0:Buy 1:Sell 2:None
     case Integer of
       0:
       //个股
      (
        Buy:Single;			// 最高叫买价
        Sell:Single;        // 最低叫卖价
        Buyp:array [0..2] of Single;		// 三个叫买价
        Buyv:array [0..2] of Cardinal;		// 对应三个叫买价的三个买盘
        Sellp:array [0..2] of Single;	// 三个叫卖价
        Sellv:array [0..2] of Cardinal	// 对应三个叫卖价的三个卖盘
       );
       1://指数
       (
         LxValue:Single;	// 领先指标
         Yield:Single;		// 不含加权的指数
         UpHome:LongInt;		// 上涨家数
         DownHome:LongInt;	// 下跌家数   ?? vc long -> delphi longint
         JJAmount:Single;	// 基金成交金额
         ZQAmount:Single;	// 债券成交金额
         GZAmount:Single;	// 国债成交金额
         QZAmount:Single;	// 权证成交金额
         QTAmount:Single	// 指数其它成交金额
       );
   end;

   tag_STOCKINFO=packed record
     Name:array [0..9] of char;			// 证券名称
     AUnit:Smallint;               // 交易单位
	 	 VolBase:LongInt;			// 量比的基量
	   cdp:Single;				// 昨日中价
	   nh:Single;					// 卖点
	   nl:Single;					// 买点
	   ah:Single;					// 高价突破点
	   al:Single;					// 低价突破点
 	   dkflag:Smallint;				// 适合作多或作空
	   tbp:Single;				// 多空平衡点
	   stoplost:Single;			// 止损点
	   leave:Single;				// 了结点

	   ActiveCapital:Single;		// 流通股本
     J_start:LongInt;			//上市日期
	   J_addr:SmallInt;				//所属省份
	   J_hy:SmallInt;				//所属行业
     J_zgb:Single;				//总股本
     J_gjg:Single;				//国家股
     J_fqrfrg:Single;			//发起人法人股
     J_frg:Single;				//法人股
     J_bg:Single;				//B股
     J_hg:Single;				//H股
     J_zgg:Single;				//职工股
     J_zzc:Single;				//总资产(元)
     J_ldzc:Single;				//流动资产
     J_gdzc:Single;				//固定资产
     J_wxzc:Single;				//无形资产
     J_cqtz:Single;				//长期投资
     J_ldfz:Single;				//流动负债
     J_cqfz:Single;				//长期负债
     J_zbgjj:Single;			//资本公积金
     J_jzc:Single;				//股东权益(就是净资产)
     J_zysy:Single;				//主营收入
     J_zyly:Single;				//主营利润
     J_qtly:Single;				//应收帐款
     J_yyly:Single;				//营业利润
     J_tzsy:Single;				//投资收益
     J_btsy:Single;				//经营现金净流量
     J_yywsz:Single;			//总现金净流量
     J_snsytz:Single;			//存货
     J_lyze:Single;				//利益总额
     J_shly:Single;				//税后利益
     J_jly:Single;				//净利益
     J_wfply:Single;			//未分配利益
     J_tzmgjz:Single;			//调整每股净资产 物理意义:  净资产/调整后的总股本
	   //增加部分
		 J_jyl:Single;				//净益率%
	   J_mgwfp:Single;			//每股未分配
	   J_mgsy:Single;				//每股收益
	   J_mggjj:Single;			//每股公积金
	   J_mgjzc:Single;			//每股净资产
	   J_gdqyb:Single;			//股东权益比
   end;

implementation

end.
